$!	setup.com
$!	V1.5			9-Oct-1997	IfN/Mey
$!+
$! Setup logicals and symbols for building/linking samba.
$!-
$! 02-Jun-1998	J. Malmberg	Adjusted for CMU-IP and GCC
$!		    *		Fix file parsing to be compatable
$!				with some national file specification
$!				syntax.
$!
$ set noon
$ on control_y then goto exit
$ on error then goto exit
$!
$ delete := delete
$ rename := rename
$!
$ df := define/nolog
$!
$! Set some directory symbols.  Directory could end in ">" or "]"
$! Structure has changed with latest test version.  This code will
$! find it correctly in either the new or old position.
$!---------------------------------------------------------------
$ procname = f$environment("PROCEDURE")
$ vms_src_dir = f$parse(procname,,,"DIRECTORY")
$ device = f$parse(procname,,,"DEVICE")
$ delim = f$extract(f$length(vms_src_dir)-1,1,vms_src_dir)
$ samba_src_dir = vms_src_dir - delim + ".-.-.source" + delim
$ samba_src_dir = f$parse(samba_src_dir,,,"directory")
$ samba_inc_dir = samba_src_dir - delim + ".include" + delim
$ samba_rpcs_dir = samba_src_dir - delim + ".lib.rpc.server" + delim
$ samba_rpcc_dir = samba_src_dir - delim + ".lib.rpc.client" + delim
$ samba_rpcp_dir = samba_src_dir - delim + ".lib.rpc.parse" + delim
$ vms_src = device + vms_src_dir
$ samba_src = device + f$parse(samba_src_dir,,,"DIRECTORY")
$ samba_inc = device + f$parse(samba_inc_dir,,,"DIRECTORY")
$ define vms_src 'vms_src'
$ define samba_src 'samba_src'
$ define samba_inc 'samba_inc'
$ define rpcsvr 'device''samba_rpcs_dir'
$ define rpccli 'device''samba_rpcc_dir'
$ define rpcprs 'device''samba_rpcp_dir'
$ set default 'samba_src'
$ root = samba_src - delim
$!
$!
$! Calculate the distribution Version
$!------------------------------------
$ dist_version = P1
$!
$ __samba_version == "1.9.16"
$ __arch == f$getsyi("ARCH_NAME")
$ __alpha == f$getsyi("ARCH_NAME") .eqs. "Alpha"
$ __decc == f$search(f$parse("DECC$COMPILER","SYS$SYSTEM:.EXE")) .nes. ""
$ __gcc == f$search("GNU_ROOT:[BIN]GCC.EXE") .nes. ""
$ __ucx == f$getdvi("UCX$DEVICE","EXISTS") .eqs. "TRUE"
$ __cmuip == f$trnlnm("CMUIP_ROOT") .nes. ""
$ __socketshr == (f$search("SOCKETSHR") .nes. "") .and. __cmuip
$! __socketshr == 0	! We currently don't support SOCKETSHR
$ __isMultiNet = f$trnlnm("MULTINET_KERNEL_BASE_ADDRESS") .nes. ""
$ __isTCPware = f$trnlnm("TCPWARE_NETCP_MBX") .nes. ""
$!
$ if .not. __decc
$ then
$   write sys$output ""
$   write sys$output -
	"The only currently supported compiler is DEC-C V5.0 and higher."
$   write sys$output ""
$   if __gcc
$   then
$	write sys$output ""
$	write sys$output "Experimental Build for using GCC"
$	write sys$output "Only tested under GCC 2.8.1 and SocketSHR / CMUIP"
$	write sys$output ""
$   else
$	goto exit
$   endif
$ endif
$!
$ write sys$output -
"VMS support for Samba 1.9.17p4 - use with other versions may not work."
$!
$! Definitions used by MMS/MMK:
$!
$ if __alpha then __alpha__ == 1
$ if __decc then __decc__ == 1
$ if __ucx then __ucx__ == 1
$ if __socketshr then __socketshr__ == 1
$ if __gcc then __gcc__ == 1
$!
$ __ucx_emu = ""
$ if __isMultiNet then __ucx_emu = "MULTINET"
$ if __isTCPware then __ucx_emu = "TCPWARE"
$
$! Configure header files.
$! Must be done before defining the CC command, since results
$! are used to define it.
$!
$ cc:=CC	! be sure cc is not defined locally
$ if __gcc
$ then
$!
$!  GCC can be run in two different ways
$!--------------------------------------
$   if f$type(gcc) .eqs. "STRING"
$   then
$	if f$extract(0,1,gcc) .eqs. "$"
$	then
$	    cc :== $GNU_ROOT:[BIN]GCC.EXE
$	else
$	    cc := GCC
$	endif
$   else
$	cc := GCC
$   endif
$endif
$!
$ write sys$output "Configure..."
$if .not. __gcc
$then
$   call configure -
    "dirent.h|.le.70000000,sys/ioctl.h,sys/wait.h|.lt.70000000,if.h,if_arp.h"
$endif
$ delete/symbol cc	! delete local definition
$!
$ if (.not.__ucx) .and. (.not.__socketshr)
$ then
$!$	type sys$input
$!
$!	You must have either SOCKETSHR or native UCX installed.
$!	Using other packages directly is not supported.
$!
$!	However, SOCKETSHR supports all TCP/IP packages (e.g. UCX, Multinet,
$!	TCPware, Pathway, CMU/IP)
$!
$!$	goto exit
$	type sys$input

	Only UCX or UCX emulation is supported!

$	goto exit
$ endif

$ if __SOCKETSHR
$ then
$!$   write sys$output "SOCKETSHR is used as TCP/IP interface."
$    write sys$output "SOCKETSHR is not and will never be supported."
$    write sys$output "However it is the only way that CMU-IP can be used."
$    write sys$output "You are making an experimental build."
$ else
$	if __ucx_emu .eqs. ""
$	then
$		write sys$output "Native UCX is used as TCP/IP interface."
$	else
$	    write sys$output -
	"''__ucx_emu' UCX emulation is used as TCP/IP interface."
$	endif
$ endif
$!
$ if f$type(mmk) .eqs. ""
$ then
$	mmk = "MMS"
$ endif
$ if .not. __SOCKETSHR
$ then
$   mms:=='mmk'/descrip='vms_src'
$   mmsd:=='mmk'/descrip='vms_src'/macro=( -
	ldebug="""/debug""", -
	cdebug="""/list=.lis_alpha/show=all""")
$ endif
$!
$ if __decc
$ then
$!
$!  02-Jun-1998	J. Malmberg	These directories do not seem to exist
$!---------------------------------------------------------------------
$!   vaxc_include = "''root'.vms.vaxc''delim'"
$!   decc_include = "''root'.vms.decc''delim'"
$    decc_include = vms_src
$!
$   if .not. __decc
$   then
$	define/nolog VAXCRTL 'f$parse("VAXCRTL","SYS$SHARE:.EXE")'
$   endif
$!
$   call defincl SYS
$   call defincl NETINET
$   call defincl ARPA
$!
$! Define CC command
$!
$   cc_decc = ""
$   if __decc
$   then
$!$	incl = ",[.vms.decc]"
$	incl = ""
$!   else
$!	incl = ",[.vms.vaxc]"
$   endif
$endif
$!
$if __socketshr  ! CMU IP Experimental Build
$then
$   smms :== 'mmk'/descrip='vms_src'samba_cmu.mms
$endif
$!
$ save_ver = f$verify(0)
$!$ set verify
$! 2-Jun-1998	J. Malmberg
$!-------------------------
$ if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$ then
$   close chan
$ endif
$ open/write chan 'samba_src'conf.h
$ write chan "/* File: CONF.H	Generated by Setup.COM"
$ write chan "**"
$ write chan "** Build dependant definitions."
$ write chan "*/"
$ write chan ""
$ write chan "#pragma module MODULE_NAME" ! MODULE_NAME is defined by BUILD.COM
$ write chan "#define _VMS_V6_SOURCE"	! don't use VMS V7 features for now
$ write chan "#define _DECC_V4_SOURCE"  ! we want (must) support older
$!					 compilers -sigh!
$ if dist_version .nes. ""
$ then
$    write chan "#undef __VMS_VER"
$    write chan "#define __VMS_VER  ''dist_version'" ! lie about VMS version
$    write chan "#define __VMS_VER2 ''dist_version'" ! remember actual version
$ else
$    write chan "#define __VMS_VER2 ''__VMS_VER'" ! remember actual version
$ endif
$ write chan "#define _stat vms_stat"	! see [.VMS]POSIXTIM.C
$ write chan "#define _fstat vms_fstat"
$ write chan "#define SMBLOGFILE ""samba_root/var/log.smb"""
$ write chan "#define NMBLOGFILE ""samba_root/var/log.nmb"""
$ write chan "#define CONFIGFILE ""samba_root:[lib]smb.conf"""
$ write chan "#define LMHOSTSFILE ""samba_root/lib/lmhosts"""
$! Note, LOCKDIR must not be terminated with a "/"
$ write chan "#define LOCKDIR ""samba_root/var/locks"""
$ write chan "#define CODEPAGEDIR ""samba_root/lib/codepages"""
$ write chan "#define SMB_PASSWD_FILE ""samba_root[bin]smbpasswd"""
$ write chan "#define SMB_PASSWD ""samba_root/private/smbpasswd"""
$ write chan "#define DRIVERFILE ""samba_root/lib/printers.def"""
$ write chan "#define SMBRUN ""smbrun"""
$ write chan "#define WORKGROUP ""LANGROUP"""
$ write chan "#define GUEST_ACCOUNT ""UCX$NOBODY"""
$!$ write chan "#define DEBUG_PASSWORD 1" ! display password with debug output
$ if __socketshr
$ then
$   write chan "#define SOCKETSHR 1"
$   write chan "#define _read si_read"
$   write chan "#define _close si_close"
$ endif
$ write chan ""
$ write chan "#define STATUS_LOCK_FILE ""STATUS_.LCK"""
$ write chan "#define STATUS_LOCK_NAME ""STATUS_"""
$ write chan ""
$if __gcc
$ then
$   write chan ""
$   write chan "#ifndef __VMS"
$   write chan "#define __VMS 1"
$   write chan "#endif"
$   write chan ""
$   write chan -
	"  /* SAMBA for VMS requires a non-standard directory descriptor    */
$   write chan -
	" /*  the field dd_loc is added to track the context between calls */
$   write chan -
	"/*---------------------------------------------------------------*/
$   write chan "struct vms_dirdesc {
$   write chan "  int dd_fd;
$   write chan "  unsigned long dd_loc;	/* store lib$find_file */
$   write chan "  long dd_size;
$   write chan "  long dd_bbase;
$   write chan "  long dd_entno;
$   write chan "  long dd_bsize;
$   write chan "  char *ddbuf;
$   write chan "};"
$   write chan ""
$   write chan -
	" /* Build a macro to allow the SAMBA to use the right structure */
$   write chan -
	"/*------------------------------------------------------------*/
$   write chan "#define VMS_DIR struct vms_dirdesc"
$   write chan "/* #define sys_opendir vms_opendir */"
$   write chan ""
$   write chan "  /* The ino_t problem, VMS uses a three word array, Unix a */
$   write chan " /*  longword.  Modified GNU stat.h to work conditionally  */
$   write chan "/*--------------------------------------------------------*/
$   write chan "#ifndef UNIX_INO_T
$   write chan "#define UNIX_INO_T
$   write chan "#endif
$!
$!
$   write chan " /* Set up some options for the handling of long file names */"
$   write chan "/*---------------------------------------------------------*/"
$   write chan -
"#define SAMBA_VMS_FILEOPTS LONGFILE_M_EXTLASTDOT | LONGFILE_M_DEEPDIR"
$   write chan ""
$ endif
$ if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$ then
$   close chan
$ endif
$!
$! Three short commands
$!
$if .not. __socketshr
$then
$   bld :== @'vms_src'build """"
$   bldlis :== @'vms_src'build """"/LIST=.LIS_'__arch'/SHOW=ALL/NOOBJ
$   lnk :== @'vms_src'delin'link
$endif
$!
$! Setup __CFLAGS
$!
$ __CFLAGS :== /include=([]'incl','vms_src')/warning=disable=(MISSINGRETURN)
$ if __decc
$ then
$   cc_decc == "/nested=primary/prefix=all"
$!'f$verify(save_ver)'
$   __CFLAGS == __CFLAGS + cc_decc
$ endif
$!
$if __gcc
$then
$   __CFLAGS :== "/include=(samba_src,samba_inc,vms_src)"
$endif
$!
$! Create .OLB
$!
$ if f$search("'samba_src'samba.olb_''__arch'") .eqs. ""
$ then
$   library/create 'samba_src'samba.olb_'__arch'
$ endif
$!
$ if dist_version .nes. "" then __VMS_VER == dist_version
$ samba_setup_done == 1
$!
$! **** EXIT ****
$!
$exit:
$ exit
$!
$! **** Subroutines ****
$!
$ defincl:
$ subroutine
$ if __decc
$ then
$!$	df 'P1' 'decc_include','root'.vms'delim'
$	df 'P1' 'root'.vms'delim'
$ else
$	df 'P1' 'vaxc_include','root'.vms'delim'
$ endif
$ endsubroutine
$!
$!
$ configure:
$!
$!	P1 - list of header files tested
$!
$ subroutine
$	tstfile := _check.c
$	lstfile := _check.lis
$	errfile := _check.err
$	if f$trnlnm("CHAN") .nes. "" then close chan
$	if f$search(tstfile) .nes. "" then delete/noconf 'tstfile'.*
$	if f$search(lstfile) .nes. "" then delete/noconf 'lstfile'.*
$	if f$search(errfile) .nes. "" then delete/noconf 'errfile'.*
$!
$! Part I - get some variables
$!
$	if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$	then
$	    close chan
$	endif
$	open/write chan 'tstfile'
$	write chan "/*_BEGIN*/"
$	write chan "/*_VAR __VMS_VER */ __VMS_VER ;"
$	write chan "/*_VAR __DECC_VER */ __DECC_VER ;"
$	write chan "/*_END_VAR*/"
$	if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$	then
$	    close chan
$	endif
$	define/user sys$output nla0:
$	define/user sys$error nla0:
$	set noon
$	cc 'tstfile' -
		/show=definition/preprocessor/list='lstfile'
$	var = ""
$	__vms_ver = "10000000"
$	__decc_ver = "10000000"
$	open/read chan 'lstfile'
$ rdloop2:
$	read/end=rdfin2/error=rdfin2 chan line
$	line2 = f$edit(line,"TRIM,COMPRESS")
$	if f$locate("/*_END_VAR*/",line2) .ne. f$length(line2) then goto rdfin2
$!
$	if f$locate("/*_VAR",line2) .ne. f$length(line2)
$	then
$		var = f$edit(f$element(1," ",line2),"TRIM")
$		'var' = f$edit(f$element(3," ",line2),"TRIM")
$	endif
$	goto rdloop2
$ rdfin2:
$	if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$	then
$	    close chan
$	endif
$	__VMS_VER == __vms_ver		! set global symbols
$	__DECC_VER == __decc_ver
$!
$! Part II - check for specified header files.
$!
$	open/write chan 'tstfile'
$	if dist_version .nes. ""
$	then
$		write chan "#undef __VMS_VER"
$		write chan "#define __VMS_VER ''dist_version'"
$		__vms_ver = dist_version ! set local symbol - used in sub only
$	endif
$	write chan "/*_BEGIN*/"
$	n = 0
$ wrloop:
$	a = f$edit(f$element(n,",",P1),"TRIM")
$	if a .eqs. "," then goto wrfin
$	hfile2 = f$edit(f$element(0,"|",a),"TRIM")
$	hfile = hfile2
$	then
$	    if f$search("''vms_src'''hfile'") .nes. ""
$	    then					! switch to "unused"
$		if f$search("''vms_src''delim'_''hfile'") .nes. ""
$		then
$		    delete 'vms_src''delim''hfile';*
$		else
$		    rename 'vms_src''hfile' 'vms_src'_'hfile'
$		endif
$	    endif
$	endif
$	if f$locate("/",hfile2) .ne. f$length(hfile2)
$	then
$	    hfile = f$edit(f$element(1,"/",hfile2),"TRIM")
$	endif
$	cond_vms_ver = f$element(1,"|",a)
$	if cond_vms_ver .eqs. "|" then cond_vms_ver = ".eq.00000000"
$	cond_decc_ver = f$element(2,"|",a)
$	if cond_decc_ver .eqs. "|" then cond_decc_ver = ".eq.00000000"
$	n = n + 1
$	if f$search("''root'.vms''delim'_''hfile'") .nes. ""
$	then			! the alternative file is at least present
$	    if (__VMS_VER 'cond_vms_ver') .or. (__DECC_VER 'cond_decc_ver')
$	    then				! unconditional use
$		rename 'vms_src'_'hfile' 'vms_src'hfile'
$	    else				! check out
$		write chan "#include <''hfile2'>"
$	    endif
$	endif
$	goto wrloop
$ wrfin:
$	write chan "/*_END*/"
$	if f$trnlnm("CHAN","LNM$PROCESS_TABLE",,"SUPERVISOR") .nes. ""
$	then
$	    close chan
$	endif
$	define/user sys$output 'errfile'
$	define/user sys$error nla0:
$	set noon
$	cc 'tstfile' -
		/show=expansion/noobject -
		/preprocessor_only=NLA0:/comment
$!
$	if f$search(errfile) .eqs. "" then goto rdfin1x
$	open/read chan 'errfile'
$	hfile = ""
$ rdloop1:
$	read/end=rdfin1/error=rdfin1 chan line
$	line2 = f$edit(line,"TRIM,COMPRESS")
$	if f$locate("/*_END*/",line2) .ne. f$length(line2) then goto rdfin1
$	if f$element(0," ",line2) .eqs. "#include"
$	then
$		hfile2 = f$element(1," ",line2) - ">" - "<"
$		hfile = hfile2
$		if f$locate("/",hfile2) .ne. f$length(hfile2)
$		then
$		    hfile = f$edit(f$element(1,"/",hfile2),"TRIM")
$		endif
$		cond_vms_ver = f$element(3," ",line2)
$		cond_decc_ver = f$element(4," ",line2)
$	endif
$	if f$locate("NOINCLFILE",line2) .ne. f$length(line2)
$	then
$	    if f$search("''vms_src'_''hfile'") .nes. ""
$	    then
$		rename 'vms_src'_'hfile' 'vms_src''hfile'
$	    endif
$	endif
$	goto rdloop1
$ rdfin1:
$	close chan
$ rdfin1x:
$!
$	if f$search(tstfile) .nes. "" then delete/noconf 'tstfile'.*
$	if f$search(lstfile) .nes. "" then delete/noconf 'lstfile'.*
$	if f$search(errfile) .nes. "" then delete/noconf 'errfile'.*
$ endsubroutine
